<?xml version="1.0" encoding="UTF-8" ?>
<!DOCTYPE mapper
        PUBLIC "-//mybatis.org//DTD Mapper 3.0//EN"
        "http://mybatis.org/dtd/mybatis-3-mapper.dtd">
<mapper namespace="com.ruoyi.project.sems.mapper.TSpecdevCcMapper">

    <resultMap type="TSpecdevCc" id="TSpecdevCcResult">
        <result property="id" column="id"/>
        <result property="plantCode" column="plant_code"/>
        <result property="unit" column="unit"/>
        <result property="carNo" column="car_no"/>
        <result property="devname" column="devname"/>
        <result property="devno" column="devno"/>
        <result property="submitdate" column="submitdate"/>
        <result property="status" column="status"/>
        <result property="delFlag" column="del_flag"/>
        <result property="createrCode" column="creater_code"/>
        <result property="createdate" column="createdate"/>
        <result property="updaterCode" column="updater_code"/>
        <result property="updatedate" column="updatedate"/>
        <result property="deptId" column="dept_id"/>
        <result property="remarks" column="remarks"/>
        <result property="remarks2" column="remarks2"/>
        <result property="approveStatus" column="approve_status"/>
        <result property="regno" column="regno"/>
        <result property="useno" column="useno"/>
        <result property="warnDate" column="warn_date"/>
        <result property="warnCycle" column="warn_cycle"/>
        <result property="nextWarnDate" column="next_warn_date"/>
        <result property="warnFlag" column="warn_flag"/>
        <result property="createUnit" column="create_unit"/>
        <result property="checkStrategy" column="check_strategy"/>
        <result property="firstWarnDate" column="first_warn_date"/>
        <result property="checkUnit" column="check_unit"/>
        <result property="docno" column="docno"/>
        <result property="approveTime" column="approve_time"/>
        <result property="changeTime" column="change_time"/>
        <result property="engineNo" column="engine_no"/>
        <result property="color" column="color"/>
        <result property="capacity" column="capacity"/>
        <result property="model" column="model"/>
        <result property="engineType" column="engine_type"/>
        <result property="devClass" column="dev_class"/>
        <result property="exUnit" column="ex_unit"/>
        <result property="useDept" column="use_dept"/>
        <result property="engineer" column="engineer"/>
        <result property="exGrade" column="ex_grade"/>
        <result property="reportNo" column="report_no"/>
        <result property="frameNo" column="frame_no"/>
        <result property="productNo" column="product_no"/>
        <result property="assetOwner" column="asset_owner"/>
        <result property="hiFlag" column="hiFlag"/>
        <result property="perTestConclusion" column="per_test_conclusion"/>
        <result property="isRepeat" column="is_repeat"/>
        <result property="plantMaint" column="plant_maint"/>
    </resultMap>

    <sql id="selectTSpecdevCcVo">
        select d.id,
               d.plant_code,
               d.unit,
               d.car_no,
               d.devname,
               d.devno,
               d.submitdate,
               d.status,
               d.del_flag,
               d.creater_code,
               d.createdate,
               d.plant_maint,
               d.updater_code,
               d.updatedate,
               d.dept_id,
               d.remarks,
               d.remarks2,
               d.approve_status,
               d.regno,
               d.useno,
               d.warn_date,
               d.warn_cycle,
               d.next_warn_date,
               d.warn_flag,
               d.create_unit,
               d.check_strategy,
               d.first_warn_date,
               d.check_unit,
               d.docno,
               d.approve_time,
               d.change_time,
               d.engine_no,
               d.color,
               d.capacity,
               d.model,
               d.engine_type,
               d.dev_class,
               d.ex_unit,
               d.use_dept,
               d.engineer,
               d.ex_grade,
               d.report_no,
               d.frame_no,
               d.product_no,
               d.asset_owner,
               s.dept_name,
               (SELECT COUNT(1) from T_SPECHI_CC h where h.DEV_ID = d.id and HI_TYPE = 0) as hiFlag,
               per_test_conclusion
                ,
               d.is_repeat
        from t_specdev_cc d
                 left join sys_dept s on s.dept_id = d.dept_id
    </sql>

    <select id="selectTSpecdevCcList" parameterType="TSpecdevCc" resultMap="TSpecdevCcResult">
        <include refid="selectTSpecdevCcVo"/>
        <where>
            <if test="plantCode != null  and plantCode != ''">and plant_code like concat(concat('%', #{plantCode}),
                '%')
            </if>
            <if test="unit != null  and unit != ''">and unit like concat(concat('%', #{unit}), '%')</if>
            <if test="carNo != null  and carNo != ''">and car_no like concat(concat('%', #{carNo}), '%')</if>
            <if test="devname != null  and devname != ''">and devname like concat(concat('%', #{devname}), '%')</if>
            <if test="devno != null  and devno != ''">and devno like concat(concat('%', #{devno}), '%')</if>
            <if test="status != null ">and d.status = #{status}</if>
            <if test="approveStatus != null ">and approve_status = #{approveStatus}</if>
            <if test="warnFlag != null ">and warn_Flag = #{warnFlag}</if>
            <if test="searchValue != null  and searchValue != ''">
                and
                (plant_code like concat(concat('%', #{searchValue}), '%')
                or unit like concat(concat('%', #{searchValue}), '%')
                or devname like concat(concat('%', #{searchValue}), '%')
                or devno like concat(concat('%', #{searchValue}), '%')
                or remarks like concat(concat('%', #{searchValue}), '%')
                or remarks2 like concat(concat('%', #{searchValue}), '%')
                or report_no like concat(concat('%', #{searchValue}), '%')

                )
            </if>
            <if test="isRepeat != null  and isRepeat != ''">
                <if test="isRepeat == 2 ">
                    and (d.REGNO, d.PLANT_CODE, d.DEL_FLAG, d.APPROVE_STATUS) IN (
                    SELECT REGNO, PLANT_CODE, DEL_FLAG, APPROVE_STATUS
                    FROM T_SPECDEV_CC
                    WHERE DEL_FLAG = 0 AND APPROVE_STATUS = 0
                    GROUP BY REGNO, PLANT_CODE, DEL_FLAG, APPROVE_STATUS
                    HAVING COUNT(*) > 1
                    )
                </if>
            </if>
            and d.del_flag = 0
        </where>
        <!-- 数据范围过滤 -->
        ${params.dataScopePlant}
        order by d.is_repeat desc, d.plant_code asc , d.unit, d.id
    </select>


    <select id="selectExpiredCc" parameterType="TSpecdevCc" resultMap="TSpecdevCcResult">
        select d.id,
               d.plant_code,
               d.unit,
               d.car_no,
               d.devname,
               d.devno,
               d.submitdate,
               d.status,
               d.del_flag,
               d.creater_code,
               d.createdate,
               d.plant_maint,
               d.updater_code,
               d.updatedate,
               d.dept_id,
               d.remarks,
               d.remarks2,
               d.approve_status,
               d.regno,
               d.useno,
               d.warn_date,
               d.warn_cycle,
               d.next_warn_date,
               d.warn_flag,
               d.create_unit,
               d.check_strategy,
               d.first_warn_date,
               d.check_unit,
               d.docno,
               d.approve_time,
               d.change_time,
               d.engine_no,
               d.color,
               d.capacity,
               d.model,
               d.engine_type,
               d.dev_class,
               d.ex_unit,
               d.use_dept,
               d.engineer,
               d.ex_grade,
               d.report_no,
               d.frame_no,
               d.product_no,
               d.asset_owner,
               per_test_conclusion
                ,
               d.is_repeat
        from t_specdev_cc d
        where SYSDATE > NEXT_WARN_DATE
          and DEL_FLAG = 0
          and STATUS = 1
        order by d.plant_code asc
    </select>

    <select id="selectTSpecdevCcListByYear" parameterType="TSpecdevCc" resultMap="TSpecdevCcResult">
        <include refid="selectTSpecdevCcVo"/>
        <where>
            <if test="status != null ">and d.status = #{status}</if>
            <if test="checkYear != null ">and to_char(NEXT_WARN_DATE,'yyyyMM') = #{checkYear}</if>
            <if test="plantIds != null  and plantIds != ''">
                and
                d.plant_code in
                <foreach collection="plantIds.split(',')" item="item" index="index"
                         open="(" close=")" separator=",">
                    #{item}
                </foreach>
            </if>
            <!--<if test="unitIds != null  and unitIds != ''">
                and
                (
                d.unit in
                <foreach collection="unitIds.split(',')" item="item" index="index"
                         open="(" close=")" separator=",">
                    #{item}
                </foreach>
                )
            </if>-->
            and d.del_flag = 0
        </where>
    </select>

    <select id="selectTSpecdevCcById" parameterType="Long" resultMap="TSpecdevCcResult">
        <include refid="selectTSpecdevCcVo"/>
        where id = #{id}
    </select>

    <insert id="insertTSpecdevCc" parameterType="TSpecdevCc">
        <selectKey keyProperty="id" resultType="long" order="BEFORE">
            SELECT seq_t_specdev_ylrq.NEXTVAL as id FROM DUAL
        </selectKey>
        insert into t_specdev_cc
        <trim prefix="(" suffix=")" suffixOverrides=",">
            <if test="id != null">id,</if>
            <if test="plantCode != null and plantCode != ''">plant_code,</if>
            <if test="unit != null">unit,</if>
            <if test="carNo != null">car_no,</if>
            <if test="devname != null">devname,</if>
            <if test="devno != null">devno,</if>
            <if test="submitdate != null">submitdate,</if>
            <if test="status != null">status,</if>
            <if test="delFlag != null">del_flag,</if>
            <if test="createrCode != null">creater_code,</if>
            <if test="createdate != null">createdate,</if>
            <if test="updaterCode != null">updater_code,</if>
            <if test="updatedate != null">updatedate,</if>
            <if test="deptId != null">dept_id,</if>
            <if test="remarks != null">remarks,</if>
            <if test="remarks2 != null">remarks2,</if>
            <if test="approveStatus != null">approve_status,</if>
            <if test="regno != null">regno,</if>
            <if test="useno != null">useno,</if>
            <if test="warnDate != null">warn_date,</if>
            <if test="warnCycle != null">warn_cycle,</if>
            <if test="nextWarnDate != null">next_warn_date,</if>
            <if test="warnFlag != null">warn_flag,</if>
            <if test="createUnit != null">create_unit,</if>
            <if test="checkStrategy != null">check_strategy,</if>
            <if test="firstWarnDate != null">first_warn_date,</if>
            <if test="checkUnit != null">check_unit,</if>
            <if test="docno != null">docno,</if>
            <if test="approveTime != null">approve_time,</if>
            <if test="changeTime != null">change_time,</if>
            <if test="engineNo != null">engine_no,</if>
            <if test="color != null">color,</if>
            <if test="capacity != null">capacity,</if>
            <if test="model != null">model,</if>
            <if test="engineType != null">engine_type,</if>
            <if test="devClass != null">dev_class,</if>
            <if test="exUnit != null">ex_unit,</if>
            <if test="useDept != null">use_dept,</if>
            <if test="engineer != null">engineer,</if>
            <if test="exGrade != null">ex_grade,</if>
            <if test="reportNo != null">report_no,</if>
            <if test="frameNo != null">frame_no,</if>
            <if test="productNo != null">product_no,</if>
            <if test="assetOwner != null">asset_owner,</if>
            <if test="perTestConclusion != null">per_test_conclusion,</if>
            <if test="plantMaint != null">plant_maint,</if>

        </trim>
        <trim prefix="values (" suffix=")" suffixOverrides=",">
            <if test="id != null">#{id},</if>
            <if test="plantCode != null and plantCode != ''">#{plantCode},</if>
            <if test="unit != null">#{unit},</if>
            <if test="carNo != null">#{carNo},</if>
            <if test="devname != null">#{devname},</if>
            <if test="devno != null">#{devno},</if>
            <if test="submitdate != null">#{submitdate},</if>
            <if test="status != null">#{status},</if>
            <if test="delFlag != null">#{delFlag},</if>
            <if test="createrCode != null">#{createrCode},</if>
            <if test="createdate != null">#{createdate},</if>
            <if test="updaterCode != null">#{updaterCode},</if>
            <if test="updatedate != null">#{updatedate},</if>
            <if test="deptId != null">#{deptId},</if>
            <if test="remarks != null">#{remarks},</if>
            <if test="remarks2 != null">#{remarks2},</if>
            <if test="approveStatus != null">#{approveStatus},</if>
            <if test="regno != null">#{regno},</if>
            <if test="useno != null">#{useno},</if>
            <if test="warnDate != null">#{warnDate},</if>
            <if test="warnCycle != null">#{warnCycle},</if>
            <if test="nextWarnDate != null">#{nextWarnDate},</if>
            <if test="warnFlag != null">#{warnFlag},</if>
            <if test="createUnit != null">#{createUnit},</if>
            <if test="checkStrategy != null">#{checkStrategy},</if>
            <if test="firstWarnDate != null">#{firstWarnDate},</if>
            <if test="checkUnit != null">#{checkUnit},</if>
            <if test="docno != null">#{docno},</if>
            <if test="approveTime != null">#{approveTime},</if>
            <if test="changeTime != null">#{changeTime},</if>
            <if test="engineNo != null">#{engineNo},</if>
            <if test="color != null">#{color},</if>
            <if test="capacity != null">#{capacity},</if>
            <if test="model != null">#{model},</if>
            <if test="engineType != null">#{engineType},</if>
            <if test="devClass != null">#{devClass},</if>
            <if test="exUnit != null">#{exUnit},</if>
            <if test="useDept != null">#{useDept},</if>
            <if test="engineer != null">#{engineer},</if>
            <if test="exGrade != null">#{exGrade},</if>
            <if test="reportNo != null">#{reportNo},</if>
            <if test="frameNo != null">#{frameNo},</if>
            <if test="productNo != null">#{productNo},</if>
            <if test="assetOwner != null">#{assetOwner},</if>
            <if test="perTestConclusion != null">#{perTestConclusion},</if>
            <if test="plantMaint != null">#{plantMaint},</if>

        </trim>
    </insert>

    <update id="updateTSpecdevCc" parameterType="TSpecdevCc">
        update t_specdev_cc
        <trim prefix="SET" suffixOverrides=",">
            <if test="plantCode != null and plantCode != ''">plant_code = #{plantCode},</if>
            <if test="unit != null">unit = #{unit},</if>
            <if test="carNo != null">car_no = #{carNo},</if>
            <if test="devname != null">devname = #{devname},</if>
            <if test="devno != null">devno = #{devno},</if>
            <if test="submitdate != null">submitdate = #{submitdate},</if>
            <if test="status != null">status = #{status},</if>
            <if test="delFlag != null">del_flag = #{delFlag},</if>
            <if test="createrCode != null">creater_code = #{createrCode},</if>
            <if test="createdate != null">createdate = #{createdate},</if>
            <if test="updaterCode != null">updater_code = #{updaterCode},</if>
            <if test="updatedate != null">updatedate = #{updatedate},</if>
            <if test="deptId != null">dept_id = #{deptId},</if>
            <if test="remarks != null">remarks = #{remarks},</if>
            <if test="remarks2 != null">remarks2 = #{remarks2},</if>
            <if test="approveStatus != null">approve_status = #{approveStatus},</if>
            <if test="regno != null">regno = #{regno},</if>
            <if test="useno != null">useno = #{useno},</if>
            <if test="warnDate != null">warn_date = #{warnDate},</if>
            <if test="warnCycle != null">warn_cycle = #{warnCycle},</if>
            <if test="nextWarnDate != null">next_warn_date = #{nextWarnDate},</if>
            <if test="warnFlag != null">warn_flag = #{warnFlag},</if>
            <if test="createUnit != null">create_unit = #{createUnit},</if>
            <if test="checkStrategy != null">check_strategy = #{checkStrategy},</if>
            <if test="firstWarnDate != null">first_warn_date = #{firstWarnDate},</if>
            <if test="checkUnit != null">check_unit = #{checkUnit},</if>
            <if test="docno != null">docno = #{docno},</if>
            <if test="approveTime != null">approve_time = #{approveTime},</if>
            <if test="changeTime != null">change_time = #{changeTime},</if>
            <if test="engineNo != null">engine_no = #{engineNo},</if>
            <if test="color != null">color = #{color},</if>
            <if test="capacity != null">capacity = #{capacity},</if>
            <if test="model != null">model = #{model},</if>
            <if test="engineType != null">engine_type = #{engineType},</if>
            <if test="devClass != null">dev_class = #{devClass},</if>
            <if test="exUnit != null">ex_unit = #{exUnit},</if>
            <if test="useDept != null">use_dept = #{useDept},</if>
            <if test="engineer != null">engineer = #{engineer},</if>
            <if test="exGrade != null">ex_grade = #{exGrade},</if>
            <if test="reportNo != null">report_no = #{reportNo},</if>
            <if test="frameNo != null">frame_no = #{frameNo},</if>
            <if test="productNo != null">product_no = #{productNo},</if>
            <if test="assetOwner != null">asset_owner = #{assetOwner},</if>
            <if test="perTestConclusion != null">per_test_conclusion = #{perTestConclusion},</if>
            <if test="isRepeat != null">is_repeat = #{isRepeat},</if>
            <if test="plantMaint != null">plant_maint = #{plantMaint},</if>

        </trim>
        where id = #{id}
    </update>

    <update id="updateTSpecdevCcByHi" parameterType="TSpecdevCc">
        update t_specdev_cc
        <trim prefix="SET" suffixOverrides=",">
            <if test="plantCode != null and plantCode != ''">plant_code = #{plantCode},</if>
            <if test="unit != null">unit = #{unit},</if>
            <if test="carNo != null">car_no = #{carNo},</if>
            <if test="devname != null">devname = #{devname},</if>
            <if test="devno != null">devno = #{devno},</if>
            <if test="submitdate != null">submitdate = #{submitdate},</if>
            <if test="status != null">status = #{status},</if>
            <if test="delFlag != null">del_flag = #{delFlag},</if>
            <if test="createrCode != null">creater_code = #{createrCode},</if>
            <if test="createdate != null">createdate = #{createdate},</if>
            <if test="updaterCode != null">updater_code = #{updaterCode},</if>
            <if test="updatedate != null">updatedate = #{updatedate},</if>
            <if test="deptId != null">dept_id = #{deptId},</if>
            <if test="remarks != null">remarks = #{remarks},</if>
            <if test="remarks2 != null">remarks2 = #{remarks2},</if>
            <if test="approveStatus != null">approve_status = #{approveStatus},</if>
            <if test="regno != null">regno = #{regno},</if>
            <if test="useno != null">useno = #{useno},</if>
            <if test="warnDate != null">warn_date = #{warnDate},</if>
            <if test="warnCycle != null">warn_cycle = #{warnCycle},</if>
            <if test="nextWarnDate != null">next_warn_date = #{nextWarnDate},</if>
            <if test="warnFlag != null">warn_flag = #{warnFlag},</if>
            <if test="createUnit != null">create_unit = #{createUnit},</if>
            <if test="checkStrategy != null">check_strategy = #{checkStrategy},</if>
            <if test="firstWarnDate != null">first_warn_date = #{firstWarnDate},</if>
            <if test="checkUnit != null">check_unit = #{checkUnit},</if>
            <if test="docno != null">docno = #{docno},</if>
            <if test="approveTime != null">approve_time = #{approveTime},</if>
            <if test="changeTime != null">change_time = #{changeTime},</if>
            <if test="engineNo != null">engine_no = #{engineNo},</if>
            <if test="color != null">color = #{color},</if>
            <if test="capacity != null">capacity = #{capacity},</if>
            <if test="model != null">model = #{model},</if>
            <if test="engineType != null">engine_type = #{engineType},</if>
            <if test="devClass != null">dev_class = #{devClass},</if>
            <if test="exUnit != null">ex_unit = #{exUnit},</if>
            <if test="useDept != null">use_dept = #{useDept},</if>
            <if test="engineer != null">engineer = #{engineer},</if>
            <if test="exGrade != null">ex_grade = #{exGrade},</if>
            <if test="reportNo != null">report_no = #{reportNo},</if>
            <if test="frameNo != null">frame_no = #{frameNo},</if>
            <if test="productNo != null">product_no = #{productNo},</if>
            <if test="assetOwner != null">asset_owner = #{assetOwner},</if>
            <if test="perTestConclusion != null">per_test_conclusion = #{perTestConclusion},</if>
            <if test="plantMaint != null">plant_maint = #{plantMaint},</if>

        </trim>
        where id = #{devId}
    </update>

    <update id="deleteTSpecdevCcById" parameterType="Long">
        update t_specdev_cc
        set del_flag = 2
        where id = #{id}
    </update>

    <update id="deleteTSpecdevCcByIds" parameterType="String">
        update t_specdev_cc set del_flag = 2 where id in
        <foreach item="id" collection="array" open="(" separator="," close=")">
            #{id}
        </foreach>
    </update>

    <select id="otherDevCount" resultType="com.ruoyi.project.sems.domain.DevData">
        SELECT COUNT(1) as num,to_char(t.NEXT_WARN_DATE,'yyyyMM') as yearM FROM "T_SPECDEV_CC" t
        where
        t.status = 1
        and del_flag = 0
        and t.PLANT_CODE in
        <foreach collection="plants" item="plant" index="index"
                 open="(" close=")" separator=",">
            #{plant}
        </foreach>

        GROUP BY to_char(t.NEXT_WARN_DATE,'yyyyMM')
    </select>

    <update id="duplicateTSpecdevCc">
        UPDATE T_SPECDEV_CC
        set DEL_FLAG = 2
        where rowid !=( select max(rowid)
        from T_SPECDEV_CC b
        where b.REGNO = T_SPECDEV_CC.REGNO and b.PLANT_CODE = T_SPECDEV_CC.PLANT_CODE  and T_SPECDEV_CC.DEL_FLAG = 0 and b.DEL_FLAG = 0
        and T_SPECDEV_CC.APPROVE_STATUS = 0
        )
    </update>

</mapper>
